﻿using System;
using Artech.EnterLibIntegration.WcfExtensions;
using Artech.WcfServices.Contracts;
namespace Artech.WcfServices.Clients
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ExceptionHandlingChannelFactory<ICalculator> channelFactory = new ExceptionHandlingChannelFactory<ICalculator>(
               "calculatorservice"))
            {
                ICalculator calculator = channelFactory.CreateChannel();
                using (calculator as IDisposable)
                {
                    try
                    {
                        int result = calculator.Divide(1, 0);
                    }
                    catch (CalculationException ex)
                    {
                        Console.WriteLine(ex.Message);
                        Console.WriteLine("InnerException");
                        Console.WriteLine("\tType:{0}", ex.InnerException.GetType());
                        Console.WriteLine("\tMessage:{0}", ex.InnerException.Message);
                    }
                }
            }

            Console.Read();
        }
    }
}